#pragma semicolon 1
#pragma ctrlchar '\'

new MaxClients;
new NULL_STRING[1];
new Float:NULL_VECTOR[3];
new Player[33][7];
new PlPresents[33][5];
new Trie:g_tSavePresents;
new g_VaultGlow;

get_players_ex(players[32], &num, GetPlayersFlags:flags, String:team[])
{
    new strFlags[10];
    get_flags(flags, strFlags, 9);
    get_players(players, num, strFlags, team);
    return 0;
}

public __reapi_version_check(majorVersion, minorVersion)
{
    if (majorVersion != 5)
    {
        new temp[512];
        formatex(temp, 511, "[ReAPI]: Api major version mismatch; expected %d, real %d", 5, majorVersion);
        set_fail_state(temp);
        return 0;
    }
    if (minorVersion < 19)
    {
        new temp[512];
        formatex(temp, 511, "[ReAPI]: Api minor version mismatch; expected at least %d, real %d", 19, minorVersion);
        set_fail_state(temp);
        return 0;
    }
    return 0;
}

public plugin_natives()
{
    register_native("EE_PrivSetPlayerGlow", "SetGlowEffects", 1);
    return 0;
}

public plugin_init()
{
    register_plugin("Privileges", "1.0", "Empty Entity");
    register_cvar("Empty Entity", "1.0", 4, 0.00);
    register_concmd("ee_plugins", "EE_Plugins", -1, "", -1, MaxClients);
    RegisterHookChain(3072, "CBasePlayer_Spawn_Post", "");
    RegisterHookChain(3076, "CBasePlayer_TraceAttack_Pre", MaxClients);
    RegisterHookChain("", "CBasePlayer_Jump_Pre", MaxClients);
    RegisterHookChain("", "CBasePlayer_ResetMaxSpeed_Pre", MaxClients);
    register_clcmd("privileges", "MainMenu", -1, "", -1, MaxClients);
    register_clcmd("amxmodmenu", "AdminMenu", -1, "", -1, MaxClients);
    register_clcmd("adminmenu", "AdminMenu", -1, "", -1, MaxClients);
    register_clcmd("admin_menu", "AdminMenu", -1, "", -1, MaxClients);
    return 0;
}

public plugin_cfg()
{
    g_tSavePresents = TrieCreate();
    g_VaultGlow = nvault_open("priv_glow");
    if (g_VaultGlow == -1)
    {
        set_fail_state("Error opening nVault!");
    }
    nvault_prune(g_VaultGlow, 0, get_systime(0) - 2592000);
    return 0;
}

public plugin_end()
{
    nvault_close(g_VaultGlow);
    return 0;
}

public client_putinserver(id)
{
    !!! Removed Phi
    Player[id][0][0][0] = 0;
    Player[id][0][0][1] = 0;
    Player[id][0][0][2] = 0;
    Player[id][0][0][3] = 0;
    Player[id][0][0][4] = 0;
    Player[id][0][0][5] = 0;
    new szSteamID[35];
    get_user_authid(id, szSteamID, 34);
    if (TrieKeyExists(g_tSavePresents, szSteamID))
    {
        TrieGetString(g_tSavePresents, szSteamID, PlPresents[id][0][0], 4, 0);
    }
    else
    {
        PlPresents[id][0][0][0] = 3;
        PlPresents[id][0][0][1] = 3;
        PlPresents[id][0][0][2] = 3;
        PlPresents[id][0][0][3] = 3;
        PlPresents[id][0][0][4] = 3;
    }
    if (get_user_flags(id, 0) & 8192)
    {
        Player[id][0][0][5] = nvault_get(g_VaultGlow, szSteamID);
        nvault_touch(g_VaultGlow, szSteamID, -1);
    }
    return 0;
}

public CBasePlayer_Spawn_Post(id)
{
    !!! Removed Phi
    if (!is_user_alive(id))
    {
        return 0;
    }
    if (Player[id][0][0][0])
    {
        set_entvar(id, "", 0.50/*1056964608*/);
    }
    if (Player[id][0][0][1])
    {
        set_entvar(id, "", 320.00/*1134559232*/);
    }
    if (Player[id][0][0][3])
    {
        Player[id][0][0][3] = 0;
    }
    if (get_user_flags(id, 0) & 8192)
    {
        SetGlowEffects(id);
    }
    return 0;
}

public CBasePlayer_TraceAttack_Pre(id, pevAttacker, Float:flDamage, Float:vecDir[3], tracehandle, bitsDamageType)
{
    !!! Removed Phi
    if (!Player[pevAttacker][0][0][0] && !Player[pevAttacker][0][0][1] && !Player[pevAttacker][0][0][2] && get_entvar(pevAttacker, 5175) && get_entvar(pevAttacker, 5152) != 8 && !Player[pevAttacker][0][0][4])
    {
        return 0;
    }
    client_print_color(pevAttacker, MaxClients, 3660);
    SetHookChainArg("", "", 0);
    return 1;
}

public CBasePlayer_Jump_Pre(id)
{
    !!! Removed Phi
    new iFlags = get_entvar(id, 5187);
    if (Player[id][0][0][3])
    {
        if (!iFlags & 512 && !iButton & 2 && iJumpNum[id][0][0] < 1)
        {
            static Float:fVelocity[3];
            get_entvar(id, 5124, fVelocity);
            fVelocity[2] = random_float(265.00, 285.00);
            set_entvar(id, 5124, fVelocity);
            iJumpNum[id]++;
        }
        else
        {
            if (iFlags & 512)
            {
                iJumpNum[id] = 0;
            }
        }
    }
    if (Player[id][0][0][2])
    {
        if (iFlags & 2048 || get_entvar(id, "") >= 2 || !iFlags & 512)
        {
            return 0;
        }
        new Float:flVelocity[3];
        get_entvar(id, 5124, flVelocity);
        flVelocity[2] = 250.00/*1132068864*/;
        set_entvar(id, 5124, flVelocity);
        set_entvar(id, "", 6);
        set_entvar(id, 5232, 0);
    }
    return 0;
}

public CBasePlayer_ResetMaxSpeed_Pre(id)
{
    !!! Removed Phi
    if (!is_user_alive(id) || !Player[id][0][0][1])
    {
        return 0;
    }
    return 1;
}

public MainMenu(id)
{
    new iMenu;
    fmt(4220, 4392);
    iMenu = menu_create(Heap_1024, "main_menu_handler", 0);
    new var1;
    if (get_user_flags(id, 0) & 16384)
    {
        var1 = 4608;
    }
    else
    {
        var1 = 4620;
    }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "MainMenu"
public MainMenu(id)

public main_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    switch (iItem)
    {
        case 0:
        {
            if (!get_user_flags(id, 0) & 16384)
            {
                MainMenu(id);
                return 1;
            }
            VipMenu(id);
        }
        case 1:
        {
            if (!get_user_flags(id, 0) & 4096)
            {
                MainMenu(id);
                return 1;
            }
            AdminMenu(id);
        }
        case 2:
        {
            if (!get_user_flags(id, 0) & 8192)
            {
                MainMenu(id);
                return 1;
            }
            CaretakerMenu(id);
        }
        case 3:
        {
            if (!get_user_flags(id, 0) & 2048)
            {
                MainMenu(id);
                return 1;
            }
            OwnerMenu(id);
        }
        default:
        {
        }
    }
    return 1;
}

public VipMenu(id)
{
    new iMenu;
    fmt(4928, 5008);
    iMenu = menu_create(Heap_1024, "vip_menu_handler", 0);
    new var1;
    if (Player[id][0][0][0])
    {
        var1 = 5304;
    }
    else
    {
        var1 = 5340;
    }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "VipMenu"
public VipMenu(id)

public vip_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    switch (iItem)
    {
        case 0:
        {
            if (!Player[id][0][0][0])
            {
                Player[id][0][0][0] = 1;
                if (is_user_alive(id))
                {
                    set_entvar(id, "", 0.50/*1056964608*/);
                }
            }
            else
            {
                Player[id][0][0][0] = 0;
                if (is_user_alive(id))
                {
                    set_entvar(id, "", 1.00/*1065353216*/);
                }
            }
        }
        case 1:
        {
            if (!Player[id][0][0][1])
            {
                Player[id][0][0][1] = 1;
                if (is_user_alive(id))
                {
                    set_entvar(id, "", 320.00/*1134559232*/);
                }
            }
            else
            {
                Player[id][0][0][1] = 0;
                if (is_user_alive(id))
                {
                    rg_reset_maxspeed(id);
                }
            }
        }
        case 2:
        {
            Player[id][0][0][2] = !Player[id][0][0][2];
        }
        case 3:
        {
            PresentMenu(id);
            return 1;
        }
        default:
        {
        }
    }
    VipMenu(id);
    return 1;
}

public PresentMenu(id)
{
    new iMenu;
    fmt(5820, 5932);
    iMenu = menu_create(Heap_1024, "present_menu_handler", 0);
    fmt(6124, 100, PlPresents[id][0][0]);
    menu_additem(iMenu, Heap_1024, "", 0, -1);
    fmt(6244, PlPresents[id][0][0][1]);
    menu_additem(iMenu, Heap_1024, "", 0, -1);
    fmt(6444, 10000, PlPresents[id][0][0][2]);
    menu_additem(iMenu, Heap_1024, "", 0, -1);
    fmt(6548, PlPresents[id][0][0][3]);
    menu_additem(iMenu, Heap_1024, "", 0, -1);
    fmt(6708, PlPresents[id][0][0][4]);
    menu_additem(iMenu, Heap_1024, "", 0, -1);
    MenuSetProp(iMenu);
    menu_display(id, iMenu, 0, -1);
    return 1;
}

public present_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    if (!is_user_alive(id))
    {
        client_print_color(id, MaxClients, 6872);
        PresentMenu(id);
        return 1;
    }
    switch (iItem)
    {
        case 0:
        {
            if (!PlPresents[id][0][0][0])
            {
                PresentMenu(id);
                return 1;
            }
            if (float(100) <= get_entvar(id, 5172))
            {
                client_print_color(id, MaxClients, 7100);
                PresentMenu(id);
                return 1;
            }
            set_entvar(id, 5172, float(100));
            PlPresents[id][0][0]--;
        }
        case 1:
        {
            if (!PlPresents[id][0][0][1])
            {
                PresentMenu(id);
                return 1;
            }
            if (Player[id][0][0][3])
            {
                client_print_color(id, MaxClients, 7280);
                PresentMenu(id);
                return 1;
            }
            Player[id][0][0][3] = 1;
            PlPresents[id][0][0][1]--;
        }
        case 2:
        {
            if (!PlPresents[id][0][0][2])
            {
                PresentMenu(id);
                return 1;
            }
            rg_add_account(id, 10000, "", "");
            PlPresents[id][0][0][2]--;
        }
        case 3:
        {
            if (!PlPresents[id][0][0][3])
            {
                PresentMenu(id);
                return 1;
            }
            if (rg_has_item_by_name(id, "weapon_hegrenade"))
            {
                client_print_color(id, MaxClients, 7528);
                PresentMenu(id);
                return 1;
            }
            rg_give_item(id, "weapon_hegrenade", MaxClients);
            PlPresents[id][0][0][3]--;
        }
        case 4:
        {
            if (!PlPresents[id][0][0][4])
            {
                PresentMenu(id);
                return 1;
            }
            if (1 <= rg_get_user_ammo(id, ""))
            {
                client_print_color(id, MaxClients, 7776);
                PresentMenu(id);
                return 1;
            }
            FN_PlayerGiveGrenade(id);
            PlPresents[id][0][0][4]--;
        }
        default:
        {
        }
    }
    new szSteamID[35];
    get_user_authid(id, szSteamID, 34);
    TrieSetString(g_tSavePresents, szSteamID, PlPresents[id][0][0], "");
    PresentMenu(id);
    return 1;
}

public AdminMenu(id)
{
    new iMenu;
    fmt(7956, 8052);
    iMenu = menu_create(Heap_1024, "admin_menu_handler", 0);
    new var1;
    if (get_entvar(id, 5175))
    {
        var1 = 8396;
    }
    else
    {
        var1 = 8360;
    }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "AdminMenu"
public AdminMenu(id)

public admin_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    switch (iItem)
    {
        case 0:
        {
            new var2;
            if (get_entvar(id, 5175))
            {
                var2 = 0;
            }
            else
            {
                var2 = 2.00/*1073741824*/;
            }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "admin_menu_handler"
public admin_menu_handler(id, iMenu, iItem)

public CaretakerMenu(id)
{
    new iMenu;
    fmt(9784, 9920);
    iMenu = menu_create(Heap_1024, "caretaker_menu_handler", 0);
    new var1;
    if (get_entvar(id, 5175))
    {
        var1 = 10280;
    }
    else
    {
        var1 = 10244;
    }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "CaretakerMenu"
public CaretakerMenu(id)

public caretaker_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    switch (iItem)
    {
        case 0:
        {
            new var2;
            if (get_entvar(id, 5175))
            {
                var2 = 0;
            }
            else
            {
                var2 = 2.00/*1073741824*/;
            }

/ * ERROR! Не удалось привести тип объекта "Lysis.DSentinel" к типу "Lysis.DReturn". * /
 function "caretaker_menu_handler"
public caretaker_menu_handler(id, iMenu, iItem)

public Invisibility(taskId)
{
    static id;
    id = taskId + -64;
    if (!is_user_connected(id))
    {
        remove_task(taskId, 0);
        return 0;
    }
    if (is_user_alive(id))
    {
        rg_set_user_rendering(id, 19, 11696, 4, 0.00);
    }
    return 0;
}

public GlowEffectsMenu(id)
{
    new iMenu;
    fmt(11708, 11864);
    iMenu = menu_create(Heap_1024, "glow_effects_menu_handler", 0);
    menu_additem(iMenu, "Убрать свечение", "", 0, -1);
    menu_additem(iMenu, "Белый", "", 0, -1);
    menu_additem(iMenu, "Красный", "", 0, -1);
    menu_additem(iMenu, "Оранжевый", "", 0, -1);
    menu_additem(iMenu, "Жёлтый", "", 0, -1);
    menu_additem(iMenu, "Зелёный", "", 0, -1);
    menu_additem(iMenu, "Голубой", "", 0, -1);
    menu_additem(iMenu, "Синий", "", 0, -1);
    menu_additem(iMenu, "Фиолетовый", "", 0, -1);
    menu_additem(iMenu, "Розовый", "", 0, -1);
    MenuSetProp(iMenu);
    menu_display(id, iMenu, 0, -1);
    return 1;
}

public glow_effects_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    Player[id][0][0][5] = iItem;
    SetGlowEffects(id);
    new szSteamID[35];
    get_user_authid(id, szSteamID, 34);
    new szBuffer[4];
    num_to_str(iItem, szBuffer, 3);
    nvault_set(g_VaultGlow, szSteamID, szBuffer);
    GlowEffectsMenu(id);
    return 1;
}

public SetGlowEffects(id)
{
    new iGlow = Player[id][0][0][5];
    switch (iGlow)
    {
        case 0:
        {
            new var1 = Heap_12;
            var1[0] = 12736;
            rg_set_user_rendering(id, 0, var1, 0, 0.00);
        }
        case 1:
        {
            rg_set_user_rendering(id, 19, 12748, 0, 25.00);
        }
        case 2:
        {
            rg_set_user_rendering(id, 19, 12760, 0, 25.00);
        }
        case 3:
        {
            rg_set_user_rendering(id, 19, 12772, 0, 25.00);
        }
        case 4:
        {
            rg_set_user_rendering(id, 19, 12784, 0, 25.00);
        }
        case 5:
        {
            rg_set_user_rendering(id, 19, 12796, 0, 25.00);
        }
        case 6:
        {
            rg_set_user_rendering(id, 19, 12808, 0, 25.00);
        }
        case 7:
        {
            rg_set_user_rendering(id, 19, 12820, 0, 25.00);
        }
        case 8:
        {
            rg_set_user_rendering(id, 19, 12832, 0, 25.00);
        }
        case 9:
        {
            rg_set_user_rendering(id, 19, 12844, 0, 25.00);
        }
        default:
        {
        }
    }
    return 0;
}

public OwnerMenu(id)
{
    new iMenu;
    fmt(12856, 12976);
    iMenu = menu_create(Heap_1024, "owner_menu_handler", 0);
    menu_additem(iMenu, "Выдать/Забрать бессмертие", "", 0, -1);
    menu_additem(iMenu, "Выдать/Забрать ноуклип", "", 0, -1);
    menu_additem(iMenu, "Выдать/Забрать оружие", "", 0, -1);
    menu_additem(iMenu, "Выдать/Забрать невидимку", "", 0, -1);
    menu_additem(iMenu, "Выдать/Забрать паутинку", "", 0, -1);
    MenuSetProp(iMenu);
    menu_display(id, iMenu, 0, -1);
    return 1;
}

public owner_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    menu_destroy(iMenu);
    if (iItem == 4)
    {
        HookTargetMenu(id);
        return 1;
    }
    Player[id][0][0][6] = iItem;
    GivePlayersMenu(id, 0);
    return 1;
}

public GivePlayersMenu(id, iPage)
{
    new iPlayers[32];
    new iCount = 0;
    new szID[4];
    get_players_ex(iPlayers, iCount, GetPlayersFlags:132, "");
    new iMenu;
    fmt(14064, 14228);
    iMenu = menu_create(Heap_1024, "give_players_menu_handler", 0);
    new i = 0;
    while (i < iCount)
    {
        static idd;
        idd = iPlayers[i];
        num_to_str(idd, szID, 3);
        fmt("%n", idd);
        menu_additem(iMenu, Heap_1024, szID, 0, -1);
        i++;
    }
    MenuSetProp(iMenu);
    menu_display(id, iMenu, iPage, -1);
    return 1;
}

public give_players_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    new szData[4];
    new var1 = Heap_4;
    var1[0] = 14456;
    menu_item_getinfo(iMenu, iItem, 0, szData, 3, var1, 0, 0);
    new idd = str_to_num(szData);
    menu_destroy(iMenu);
    if (!is_user_connected(idd))
    {
        client_print_color(id, MaxClients, 14460);
        OwnerMenu(id);
        return 1;
    }
    new iGiveMenu = Player[id][0][0][6];
    switch (iGiveMenu)
    {
        case 0:
        {
            if (get_entvar(idd, 5175))
            {
                set_entvar(idd, 5175, 0);
                client_print_color(id, MaxClients, 15284, idd);
                client_print_color(idd, MaxClients, 15604, id);
            }
            else
            {
                set_entvar(idd, 5175, 2.00/*1073741824*/);
                client_print_color(id, MaxClients, 14656, idd);
                client_print_color(idd, MaxClients, 14996, id);
            }
        }
        case 1:
        {
            if (get_entvar(idd, 5152) == 8)
            {
                set_entvar(idd, 5152, 3);
                client_print_color(id, MaxClients, 15872, idd);
                client_print_color(idd, MaxClients, 16188, id);
            }
            else
            {
                set_entvar(idd, 5152, 8);
                client_print_color(id, MaxClients, 16452, idd);
                client_print_color(idd, MaxClients, 16748, id);
            }
        }
        case 2:
        {
            GiveWeaponsMenu(id, idd);
            return 1;
        }
        case 3:
        {
            if (!Player[idd][0][0][4])
            {
                Player[idd][0][0][4] = 1;
                rg_set_user_rendering(idd, 19, 16992, 4, 0.00);
                set_task(1.00, "Invisibility", idd + 64, "", 0, "b", 0);
                client_print_color(id, MaxClients, 17064, idd);
                client_print_color(idd, MaxClients, 17444, id);
            }
            else
            {
                Player[idd][0][0][4] = 0;
                SetGlowEffects(idd);
                remove_task(idd + 64, 0);
                client_print_color(id, MaxClients, 17772, idd);
                client_print_color(idd, MaxClients, 18172, id);
            }
        }
        default:
        {
        }
    }
    GivePlayersMenu(id, iItem / 7);
    return 1;
}

public GiveWeaponsMenu(id, idd)
{
    new iMenu;
    fmt(18520, 18740, idd);
    iMenu = menu_create(Heap_1024, "give_weapons_menu_handler", 0);
    new szID[4];
    num_to_str(idd, szID, 3);
    menu_additem(iMenu, "Забрать всё", szID, 0, -1);
    menu_additem(iMenu, "Deagle", szID, 0, -1);
    menu_additem(iMenu, "AK-47", szID, 0, -1);
    menu_additem(iMenu, "M4A1", szID, 0, -1);
    menu_additem(iMenu, "AWP", szID, 0, -1);
    MenuSetProp(iMenu);
    menu_display(id, iMenu, 0, -1);
    return 1;
}

public give_weapons_menu_handler(id, iMenu, iItem)
{
    if (iItem == -3)
    {
        menu_destroy(iMenu);
        return 1;
    }
    new szData[4];
    new var1 = Heap_4;
    var1[0] = 14456;
    menu_item_getinfo(iMenu, iItem, 0, szData, 3, var1, 0, 0);
    new idd = str_to_num(szData);
    menu_destroy(iMenu);
    if (!is_user_connected(idd))
    {
        client_print_color(id, MaxClients, 19128);
        OwnerMenu(id);
        return 1;
    }
    switch (iItem)
    {
        case 0:
        {
            rg_remove_items_by_slot(idd, "");
            rg_remove_items_by_slot(idd, "");
            client_print_color(id, MaxClients, 19324, idd);
            client_print_color(idd, MaxClients, 19652, id);
        }
        case 1:
        {
            rg_give_item(idd, "weapon_deagle", MaxClients);
            client_print_color(id, MaxClients, 19984, idd);
            client_print_color(idd, MaxClients, 20248, id);
        }
        case 2:
        {
            rg_give_item(idd, "weapon_ak47", MaxClients);
            client_print_color(id, MaxClients, 20508, idd);
            client_print_color(idd, MaxClients, 20768, id);
        }
        case 3:
        {
            rg_give_item(idd, "weapon_m4a1", MaxClients);
            client_print_color(id, MaxClients, 21024, idd);
            client_print_color(idd, MaxClients, 21280, id);
        }
        case 4:
        {
            rg_give_item(idd, "weapon_awp", MaxClients);
            client_print_color(id, MaxClients, 21528, idd);
            client_print_color(idd, MaxClients, 21780, id);
        }
        default:
        {
        }
    }
    GiveWeaponsMenu(id, idd);
    return 1;
}

MenuSetProp(menu)
{
    menu_setprop(menu, 10, "\r");
    menu_setprop(menu, 2, 21992);
    menu_setprop(menu, 3, 22036);
    menu_setprop(menu, 4, 22080);
    menu_setprop(menu, 6, 1);
    return 0;
}

public EE_Plugins(id)
{
    console_print(id, "%s (last update: %s)", "Privileges", "12.14.2023");
    return 0;
}

rg_set_user_rendering(index, fx, Float:fColor[3], render, Float:amount)
{
    set_entvar(index, 5171, fx);
    set_entvar(index, "", fColor);
    set_entvar(index, 5168, render);
    set_entvar(index, "", amount);
    return 0;
}

